/* PRECCX.Y
*/

# define TOKEN char
# define VALUE char*
# define STACKTOKENS 1
# define STACKSIZE 2048

# define BEGIN p_pbegin(self)
# define END

# define START 
# define FINISH p_pfinish()


# define PRECC_Y /* signal to get precc's special V(x), T(x)  macros */
# include "cc.h"
# include "preccx.h"
# undef UNSETNAME
# include "preamble.h"







#include <errno.h>
#include <time.h>

/* generated prototypes */
#include "cp"
#include "lexp"
#include "preccxp"

FILE *protos = (FILE*)NULL;/* auxiliary FP, use like stdout, etc. */

static int p_pbegin(PRECC_DATA * self){
        static int passes; /* no. of times re-entered MAIN */
        int narg;          /* no of command line args */
        int nswitch;       /* count of command line switches */
        int switches;      /* flag - when doing command line switches */
        /*int dup2(int,int);*/
        
        struct tm *date;   /* current date */
        time_t ltime;      /* local time */

        if(passes++==0){   /* print motto */
                printf("\n\
/*    PRE-CC %d.%d compiler-compiler %s \n\
 *       Copyright Peter Breuer 1989-1998\n\
 *             <ptb@it.uc3m.es>\n\
 */\n\
",__PRECC__,__DATE__);
            call_mode=1;/* set no-auto shift in value stack */
            dup2(0,5);  /* save stdin and stdout */
            dup2(1,6);
            dup2(2,7);  /* and stderr */
            nswitch=0;  /* begin command line processing */
            switches=1;
            for (narg=1;narg<p_argc;narg++){
                switch(p_argv[narg][0]){
                case '-':
                    if(!switches) 
                      if (p_argv[narg][1])
                        usage (self,1); /* mixed switches/files */
                      else
                        break;          /* just file name "-" */
                    nswitch++;
                    switch(p_argv[narg][1]){
                    case '-': 
                        if (p_argv[narg][2]) /* unknown option */
                          usage(self,3);
                        switches=0;     /* o/w end of switches */
                        break;
                    case 'r': /* read buffer size in Kb */
                        getkintarg(self,p_argv[narg]+2,& self->readbuffersize,
                                   sizeof (TOKEN) + sizeof (VALUE));
                        break;
                    case 'p': /* internal program length in Kb */
                        getkintarg(self,p_argv[narg]+2,& self->maxprogramsize,
                                   sizeof (P_INSTRUCTION));
                        break;
                    case 'v': /* internal VALUE stack size in Kb */
                        getkintarg(self,p_argv[narg]+2,& self->stacksize,
                                   sizeof (P_STACKVALUE));
                        break;
                    case 'f': /* internal FRAME stack size in Kb */
                        getkintarg(self,p_argv[narg]+2,& self->contextstacksize,
                                   sizeof (P_FRAME));
                        break;
                    case 'c': /* internal stuff buffer size in Kb */
                        getkintarg(self,p_argv[narg]+2,&cbuffsize,
                                   sizeof (char));
                        break;
                    case 'n': /* internal name buffer size in Kb */
                        getkintarg(self,p_argv[narg]+2,&nbuffsize,
                                   sizeof (char));
                        break;
                    case 'o': 
                        if (0==strcmp(p_argv[narg]+1,"old"))
                            self->oldattributes=1;
                        else
                            self->oldattributes=0;
                        break;
                    default: /* unknown option */
                        usage(self,3);
                    }
                    break;
                default:
                    switches=0; /* end of switches */
                    break;
                }
            }                   /* now deal with redirects */
            p_infile = p_outfile = p_errfile = p_auxfile = "-"; /* in/out/err file names */
            switch(p_argc-1-nswitch){
            case 4:
                    if (strcmp(p_argv[nswitch+4],"-"))
                    if (!protos)
                      if (protos = fopen(p_auxfile=p_argv[nswitch+4], "w"), !protos)
                        usage (self,8);
                    else
                      if (!freopen(p_auxfile=p_argv[nswitch+4], "w", protos))
                        usage (self,8);
            case 3:
                    if (strcmp(p_argv[nswitch+3],"-"))
                    if (!freopen(p_errfile=p_argv[nswitch+3], "w", stderr))
                      usage (self,7);
            case 2:
                    if (strcmp(p_argv[nswitch+2],"-"))
                    if (!freopen(p_outfile=p_argv[nswitch+2], "w", stdout)) 
                      usage (self,2);
            case 1:
                    if (strcmp(p_argv[nswitch+1],"-"))
                    if (!freopen(p_infile=p_argv[nswitch+1], "r", stdin)) 
                      usage (self,5);
            case 0: break;
            default: /* too many files named on commandline */
                    usage (self,6);
            }
      time(&ltime);
      date = localtime(&ltime);
      printf("\n");
      printf("/* code generated by PRECCX %d.%d\n *  %s */\n",
              __PRECC__,asctime(date));
      if (protos)
        fprintf(protos,"/* code generated by PRECCX %d.%d\n *  %s */\n",
              __PRECC__,asctime(date));
#ifdef MVS
      /* for MVS */
      fprintf(stdout,"\n\?\?=pragma filetag(\"IBM-284\")\n\n");
      if (protos)
        fprintf(protos,"\n\?\?=pragma filetag(\"IBM-284\")\n\n");
#endif
            if (self->yylex != precc_yylex) {
               /* install our lexer */
               self->yylex = precc_yylex;
               self->yywrap = precc_yywrap;
               self->yytcharp = &precc_yytchar;
               self->yylinenop = &precc_yylineno;
               self->yylenp = &precc_yylen;
               self->yyllocp = &precc_yylloc;
               self->yylvalp = &precc_yylval;  
            }
	    {
	      /* remake data in case sizes have changed */
	      p_destr_data(self);
	      p_creat_data(self);
              p_creat_intern_data();
	    }
            if (protos)
              fprintf(protos,"P_BEGIN\n");
        }
        /* else passes > 0 */
        return 0;                /* success */
}

char *envs[PSTACKLENGTH];      /*environment stack*/
char *plvs[PSTACKLENGTH];      /*plainenv    stack*/
int  ecount=0;                 /*pointer */
int  countstack[PSTACKLENGTH]; /*stack of number of sequents we have seen */
int  countcount =0;            /*pointer */


void __cdecl pushenv()
/* save the current environment and begin another */
{
    ecount++;
}

void __cdecl popenv()
/* release the current env and recall the old */
{
    ecount--;
}

void __cdecl pushcount()
/* save the current count of sequents and begin another */
{
    countcount++;
    /* the next line disambiguates references in blocks, but that is
     * probably not what is wanted.
     */
    /* count = countcount*PSTACKLENGTH + 1; */
    /* this next line does no disambiguation
     * and therefore causes warnings from C code,
     * but it doesn't matter.
     */
    count = 1;
}
void __cdecl popcount()
/* release the current count of sequents and recall the old */
{
    countcount--;
}
int __cdecl getcount()
/* return the current count level for sequents */
{
    return countcount;
}


                /* -- idens with params ------- */

@ nameplusargs =  IDENTIFIER [ rdbrktargs :VV(2)=V(1);: ] 

@ nameplusvars =  IDENTIFIER [ rdbrktvars :VV(2)=V(1);: ] 

@ sqbrktargs = openbracket
@              WHITESPACE theargs WHITESPACE
@              closebracket :VV(5)=V(3);: 

@ rdbrktargs = openparen
@              WHITESPACE theargs WHITESPACE
@              closeparen   :VV(5)=V(3);: 

@ rdbrktvars = openparen
@              WHITESPACE thevars WHITESPACE
@              closeparen   :VV(5)=V(3);: 

/* these are token-driven writes */

@ openparen    = OPENPAREN  : VV(1) = putchar(T(1)); :

@ closeparen   = CLOSEPAREN : VV(1) = putchar(T(1)); :

@ openbracket  = OPENBRACKET  : VV(1) = putchar(T(1)); :

@ closebracket = CLOSEBRACKET : VV(1) = putchar(T(1)); :

@ openbrace    = OPENBRACE  : VV(1) = putchar(T(1)); :

@ closebrace   = CLOSEBRACE : VV(1) = putchar(T(1)); :

@ semicolon    = SEMICOLON  : VV(1) = putchar(T(1)); :

# define NLCONV(x) ((x)=='\b'?'\n':(x)) /* undo yylex \n->\b conversion */

@ space        = SPACE : VV(1) = putchar(NLCONV(T(1))); :

@ whitespace   = space { space : VV(2) = V(1); : }*
@              | : VV(0)=""; :

@ theargs = someargs
@         |  : VV(0)=""; :

@ thevars = somevars
@         |  : VV(0)=""; :

@ comma = COMMA : VV(1)=putchar(','); :

@ someargs =expr { WHITESPACE  comma WHITESPACE expr :VV(5)=V(1);: }*


@ somevars =var  { WHITESPACE  comma WHITESPACE var  :VV(5)=V(1);: }*


@ var   = IDENTIFIER
@                :if(*putargs(""))putargs(",");putargs("PARAM ");putargs(V(1));
@                 if(*putmeta(""))putmeta(",");putmeta(V(1));:

@ typename = IDENTIFIER :putargs(V(1));:
@            [ WHITESPACE STAR : VV(3)=V(1); putchar('*');: ]
@            :putchar(',');:

@ attrname = IDENTIFIER :putargs(V(1));putchar(',');:

@ classname = IDENTIFIER :getname(&V(1));:

@ unionname = IDENTIFIER

                /* -- parser identifiers --- */

/* collect IDENTIFIERs from buffers */

void __cdecl SETENV()
/* seal the current environment to be whats in the buffers now */
{
  environment=putargs("");
  plainenv=putmeta("");
  getargs(&environment);
  getmeta(&plainenv);
}

char * __cdecl LASTVAR()
/* last variable in the current environment */
{
char *s;
if (ecount<0)
  return (char*)NULL;
s = strchr(plainenv,',');
if (!s)
  return plainenv;
return s+1;
}

/* first item written in a declaration block */
@ declname = nameplusvars :getname(&V(1));SETENV();:

/* to make #line references to definitions immediately before the
   first STATUS foo line in the emitted code, insert P_LINE; before the
   getname above */


/* collect a domain IDENTIFIER in the same way */

@ exprname = nameplusargs :getname(&V(1));:


                /* -- start of precc defn ----   */

@ union_attr  = 
@               unionname : putchar(','); :

@ union_attrs = union_attr
@               { { WHITESPACE { SEMICOLON | COMMA } WHITESPACE :VV(3)=V(2);: | SOMESPACE } union_attr  :VV(3) = V(1);: }*
@               [ WHITESPACE { COMMA | SEMICOLON } :VV(3)=V(1);: ]

@ union_decl  = ^ AT  WHITESPACE AT UNION WHITESPACE !{union_declerr}
@              :printf("P_BEGIN\n");:
@              { classname | :VV(0)="param";: }
@              WHITESPACE OPENBRACE WHITESPACE
@              union_attrs
@              WHITESPACE CLOSEBRACE WHITESPACE
@              :VV(15) = P_UNION(V(8),V(12));countcount=0; RESET;:
@              :printf("P_END\n");:

@ class_opt   = OPENPAREN
@               WHITESPACE CNAME
@               WHITESPACE EQUALS
@               WHITESPACE IDENTIFIER : putchar(','); :
@               WHITESPACE CLOSEPAREN
@               :VV(9)=V(7);:

@ class_attr  = typename WHITESPACE attrname
@               { WHITESPACE class_opt :VV(2)=V(1);: | :VV(0)="";putchar(',');: }
@               WHITESPACE OPENBRACKET
@               WHITESPACE integer
@               WHITESPACE CLOSEBRACKET
@               : VV(10) = V(1); putchar(';'); :

@ class_attrs = class_attr
@               { WHITESPACE SEMICOLON WHITESPACE class_attr :VV(5) = V(1);: }*
@               [ WHITESPACE SEMICOLON : VV(3) = V(1); :]
@             | :VV(0)=""; :

@ class_decl  = ^ AT  WHITESPACE AT CLASS WHITESPACE !{class_declerr}
@              classname
@              WHITESPACE
@              :printf("P_BEGIN\n");:
@              OPENBRACE WHITESPACE
@              class_attrs
@              WHITESPACE CLOSEBRACE WHITESPACE
@              :VV(15) = P_CLS(V(8), V(12));countcount=0; RESET;:
@              :printf("P_END\n");:

@ declaration = ^ AT !{declerr} WHITESPACE declname
@              WHITESPACE EQUALS WHITESPACE
@              :printf("P_BEGIN\n");:
@              expression WHITESPACE
@              :VV(10) = P_REN(V(5),V(9));countcount=0;RESET;:
@              :printf("P_END\n");:

/* to make #line references to definitions immediately before the
   STATUS foo line in the emitted code, insert P_LINE; before the
   VV above */

void __cdecl ADDVAR(char *x)
/* make a new environment with one more var. save the old. */
{
  char *n;
                 /* finish off current env */
  getargs(&n);
  getmeta(&n);
                 /* copy old to new - start by buffering it */
  putargs(environment);
  putmeta(plainenv);
                 /* increment env count */
  pushenv();
                 /* point env at buffer */
  environment=putargs("");
  plainenv=putmeta("");
                 /* add new var */

  if (is_in(x,plainenv))
      return;    /* unless already there */

  if(*environment){
    putargs(",");
    putmeta(",");
  }
  putargs("VALUE ");  /* this is a special kind of new variable */
  putargs(x);
  putmeta(x);
                 /* note that the buffer is still unterminated */
}

@ printunion_declerr =  :VV(0)="@";
@                 fprintf(stderr,"line %d error: malformed UNION \n@?",*self->yylinenop); :

@ union_declerr = printunion_declerr
@           passthrough :VV(2)=V(1);:

@ printclass_declerr =  :VV(0)="@";
@                 fprintf(stderr,"line %d error: malformed CLASS \n@?",*self->yylinenop); :

@ class_declerr = printclass_declerr
@           passthrough :VV(2)=V(1);:

@ printdeclerr =  :VV(0)="@";
@                 fprintf(stderr,"line %d error: malformed declaration\n@?",*self->yylinenop); :

@ declerr = printdeclerr
@           passthrough :VV(2)=V(1);:

                /* that was it. Now the top level (MAIN) parse. */

@ line = class_decl
@      | union_decl
@      | declaration
@      | notanat passthrough
@      |  :VV(0)="";printf("\n");:

@ notanat = NOTANAT : VV(1)=putchar(T(1)); :

/* this is a deliberate pop of the value 'behind'  if we get none */

@ passthrough = {anychar : VV(2)=V(1); :}*
@                :getname(&V(1));printf("%s\n",V(1)); RESET;:

@ anychar = ANYTHING : VV(1)=putchar(T(1)); :

                /* ----  parser expressions -------- */

@ expression = alternates
@            | empty

/* a <'|'> separated series, at least one <'|'>  - note the overpull 
   I prefer the order which results from recursion */

@ alternates = sequence
@              [ WHITESPACE OR WHITESPACE alternates
@                :char *n;
@                 VV(5)=(GETNEWNAME(&n,plainenv),P_ALT(n,V(1),V(5)));:
@              ]

/* appending is much more efficient than prepending because I don't waste
  C-stack space with MARK before a parse */

/* this is a command separated sequence of sequents which are not commands
*/

@ sequence = manysequents 
@            { 
@              WHITESPACE command
@              WHITESPACE manysequents
@                 :char *n;
@                  VV(3)=(GETNEWNAME(&n,plainenv),P_AND(n,V(1),V(3)));:
@            }*
@            [ WHITESPACE command ]

 /* here we attach to the manysequents which this follows */

@ command =  COLON c_code COLONorEOL
@           : char *n,*m;
@             VV(5)=(GETNEWNAME(&n,plainenv),GETNEWNAME(&m,plainenv),P_ATT(m,V(1),n,V(4))); :

char *trim_trailing_colon(char *x) {
    int n = strlen(x);
    if (n > 0 && x[n-1] == ':') {
        x[n-1] = 0;    
    }
    return x;
}

@ bracketcommand = OPENBRACE COLON c_code3 WHITESPACE CLOSEBRACE
@           : char *n,*m;
@             VV(5)=(GETNEWNAME(&n,plainenv),GETNEWNAME(&m,plainenv),P_ATT(m,"p_nothing0",n,trim_trailing_colon(V(3)))); :
@                | COLON OPENBRACE c_code3 WHITESPACE CLOSEBRACE { COLON | : VV(0)="";: }
@           : char *n,*m;
@             VV(6)=(GETNEWNAME(&n,plainenv),GETNEWNAME(&m,plainenv),P_ATT(m,"p_nothing0",n,V(3))); :
@                | OPENBRACE SEMICOLON c_code3 WHITESPACE CLOSEBRACE
@           : char *n,*m;
@             VV(5)=(GETNEWNAME(&n,plainenv),GETNEWNAME(&m,plainenv),P_ATT(m,"p_nothing0",n,V(3))); :


/* manysequents is a 0 or more long list of nonempty non-commands */

/* start a new count */

/* do the pulling in moresequents, if it happens */

@ manysequents = firstsequent [ moresequents ] : popcount();:

/* need "empty newvar empty" and "sequent newvar empty" to make the
   above complete, but it's too much bother right now */

@ firstsequent = { sequent
@                | empty
@                }            :pushcount();:


        /* overpull again in the option 
           again, I prefer to use recursion for better output order */

/* without a parameterized spec, I can't prevent repetitions */

@ newvar = BACKSLASH IDENTIFIER
@     :VV(2)=V(2);getname(&V(2));ADDVAR(V(2));:
@        | BACKSLASH OPENBRACE cstuffs3 CLOSEBRACE WHITESPACE IDENTIFIER
@     :VV(6)=V(6);getname(&V(6));ADDVAR(V(6));:

/* moresequents is a 1 or more long list of sequents, or an attr decl
 * followed by a 1 or more long list. It is not empty. It is not
 * (presently) a newvar on its own, though it might eventually be */

@ moresequents = newvar WHITESPACE sequent [ moresequents ]
@        : char *n; VV(4)=V(1);popenv();
@          GETNEWNAME(&n,plainenv);V(1)=P_STAR(n,V(1),V(4),V(2));:
@              | dummyvar WHITESPACE sequent [ moresequents ]
@        : char *n; VV(4)=V(1);
@          if (self->oldattributes){popenv();
@          GETNEWNAME(&n,plainenv);V(1)=P_STAR(n,V(1),V(4),V(2));}
@          else{
@          GETNEWNAME(&n,plainenv);V(1)=P_AND(n,V(1),V(4));}:

/* in the above, have to be careful to avoid allowing a trailing "empty"
   because that wrecks the returned value from an @foo@ */

@ dummyvar =  :/*empty*/ VV(0)=V(1);
@             if(self->oldattributes){
@             getname(&V(1));
@             GETANAME(&V(1),"p_","",count++);
@             V(1)=GNAME(V(1));putname(V(1));
@             getname(&V(1));
@             ADDVAR(V(1)); }

        /* Don't overpull now because ... */

@ sequent = seqoperand [ postfix ] 

        /* in each of these cases the postfix must behave as though the
        seqoperand were before it and overpull its arguments and write into
        the stack position to the left of itself */


@ postfix = starop
@         | plusop 
@         | hideop

@ bracket = OPENBRACE WHITESPACE
@           expression
@           WHITESPACE CLOSEBRACE
@    : VV(5) = V(3); :

@ option =  OPENBRACKET WHITESPACE
@           expression
@           WHITESPACE CLOSEBRACKET
@   : char *n;VV(5)=(GETNEWNAME(&n,plainenv),P_OPT(n,V(3))); :

@ empty =  : VV(0)= "p_nothing0"; :


@ result=  AT WHITESPACE expr WHITESPACE AT
@                 :char *n; VV(5)=(getname(&V(3)),
@                  GETNEWNAME(&n,plainenv),P_ATA(n,V(3))); :

char *trim_trailing_at(char *x) {
    int n = strlen(x);
    if (n > 0 && x[n-1] == '@') {
        x[n-1] = 0;    
    }
    return x;
}

@ bracketresult=  OPENBRACE AT WHITESPACE cstuffs3 CLOSEBRACE
@                 :char *n; VV(5)=(trim_trailing_at(V(4)),getname(&V(4)),
@                  GETNEWNAME(&n,plainenv),P_ATA(n,V(4))); :
@              |  AT OPENBRACE WHITESPACE cstuffs3 CLOSEBRACE AT 
@                 :char *n; VV(6)=(getname(&V(4)),
@                  GETNEWNAME(&n,plainenv),P_ATA(n,V(4))); :


                /* here is one overpull */

int starflag=0;
char *starqual;

/* can't allow "a * n" because it can't be distinguished from "a* b" */

@ starop = STAR [ expr :starflag=1;VV(2)=(getname(&V(2)),V(2));: ]
@          : char *n;if(starflag){
@                  VV(2)=(GETNEWNAME(&n,plainenv),P_ITR(n,V(1),V(3))); 
@                  }  else {
@                  VV(2)=(GETNEWNAME(&n,plainenv),P_INF(n,V(1)));
@                  }  starflag=0; :

@ anymatch = QUESTION : VV(1)="p_anything0"; :

/* recall that exprnames get saved in the cbuff */


@ seqoperand = bracketcommand
@            | bracketresult
@            | brackettest
@            | bracket
@            | option
@            | lswitch
@            | literal
@            | antiliteral
@            | rswitch  
@            | range  
@            | test
@            | phantom
@            | result
@            | anymatch | beginmatch | eofmatch | untilmatch
@            | dollarplingmatch | finishmatch
@            | plingexpr | plingcall
@            | plingmatch | exprname
@            | notseqoperand


@ plingexpr  = PLING bracket 
@     : char *n;   VV(2)=(GETNEWNAME(&n,plainenv),P_ERR(n,V(2))); :

@ phantom = CLOSEBRACKET WHITESPACE
@              expression
@           WHITESPACE OPENBRACKET
@           :char *n;VV(5)=(GETNEWNAME(&n,plainenv),P_PHA(n,V(3))); :


/* ----------- subtokens of large "tokens" --------------------------- */

/* a literal is anything inside angle brackets.
 * an antiliteral is anything inside anti angle brackets.
 * anglebrackets inside may be escaped to protect them
 */

@ lstuff = STRING 
@        | CHARCONST
@        | DEREF
@        | COMMENT
@        | NOTARIGHTANGLEBRACKET : VV(1) = putchar(T(1)); :

@ alstuff = STRING  
@         | CHARCONST
@         | DEREF
@         | COMMENT
@         | NOTALEFTANGLEBRACKET : VV(1) = putchar(T(1)); :


/* anything except : */

@ cstuff = STRING
@        | CHARCONST
@        | DEREF
@        | COMMENT
@        | IDENTIFIER
@        | NUMBER
@        | NOTACOLON : VV(1) = putchar(NLCONV(T(1))); :


@ DEREF  = DEREF_BEGIN WHITESPACE
@          IDENTIFIER SOMESPACE
@          :putname(",(");:
@          IDENTIFIER
@          :putname("),(");:
@          RARROW 
@          cstuff3
@          :putname(")");:
@          WHITESPACE CLOSEBRACE
@          : VV(9) = putchar(')'); :
@        | DOLLARID

@ DEREF_BEGIN
@        = { { AMPERSAND | AT ADDROF : VV(2)=V(1);: } 
@            :putname("P_PARAM_GET(");:
@          | { HASHMARK | AT SIZEOF : VV(2)=V(1);: }
@            :putname("P_PARAM_SIZE(");:
@          | { QUESTION | AT TYPEOF :VV(2)=V(1);: }
@            :putname("P_PARAM_TYPE(");:
@          | { DOLLAR | AT MULTOF :VV(2)=V(1);: }
@            :putname("P_PARAM_MULT(");:
@          } OPENBRACE
@          : VV(2)=V(1); :

/* anything except a final unbalanced } allowing { } pairs in the interior */

@ cstuff3= STRING
@        | CHARCONST
@        | DEREF
@        | COMMENT
@        | IDENTIFIER [ openparen cstuffs3 closeparen  : VV(4) = V(1); : ]
@        | NUMBER
@        | openbrace cstuffs3 closebrace : VV(3) = V(1); :
@        | NOTACLOSEBRACE : VV(1) = putchar(NLCONV(T(1))); :

//@        | openparen cstuffs3 closeparen : VV(3) = V(1); :

/* -------------------------------------------------------------------- */


/* ------- let a stream flow by, while engraving itself in cbuff ------ */

@ lstuffs  = lstuff { lstuff : VV(2) = V(1); : }*
@          |  : VV(0)=""; :

@ alstuffs = alstuff { alstuff : VV(2) = V(1); : }*
@          |  : VV(0)=""; :

/* the stuff inside a command is a sequence of C constants or C tokens */

@ cstuffs= cstuff { cstuff : VV(2) = V(1); : }*
@        |  : VV(0) =""; :

/* this kind of interior of a command ends only at a } */

@ cstuffs3= cstuff3 { cstuff3 : VV(2) = V(1); : }*
@        |  : VV(0) =""; :


/* ------------------------------------------------------------------- */



/* ------------- close the cbuff accumulator  ------------------------ */

@ lits     = lstuffs :VV(1)=V(1);getname(&V(1));:

@ alits    = alstuffs :VV(1)=V(1);getname(&V(1));:

@ tlits    = cstuffs3 :VV(1)=V(1);getname(&V(1));:

@atlits    = cstuffs3 :VV(1)=V(1);getname(&V(1));:

/* commands didn't use to be able to be treated as ordinary atoms, because they
 * were required to end a sequence of 'and's and force a stack shift */

@ c_code   = cstuffs : VV(1)=V(1); getname(&V(1)); :

/* otoh, this kind of command is an atom - it has code inside {; ;} pairs */

/* till a } */

@ c_code3= cstuffs3 : VV(1)=V(1); getname(&V(1)); :

# define MAXCASES 256
int ncase = 0;
char *cases[MAXCASES][2];
/*
 * free memory for cases n <= x < ncase
 */
void freecases(int n) {
    while(--ncase >= n) {

        int i;

        for (i = 0; i < 2; i++)  {
            if (cases[ncase][i])
                free(cases[ncase][i]);
        }
    }
    ncase++;
}
int addcase(char *label, char *fn) {
    if (ncase >= MAXCASES)
        return -1;
    cases[ncase][0] = label ? strdup(label) : NULL;
    cases[ncase][1] = fn ?    strdup(fn)    : NULL;
    return ncase++;
}
/*
 * print out cases for n <= x < ncase
 */
int dumpcases(int offset, int n) {

    int i, j;

    for (i = n; i < ncase; i++) {
       for (j = 0; j < offset; j++) {
           printf(" ");
       }
       if (cases[i][0]) {
           printf("case %s:", cases[i][0]);
       } else {
           printf("default:");
       }
       if (cases[i][1]) {
           printf(" return %s(self%s%s);\n",
               GNAME(cases[i][1]), !ISEMPTY(plainenv)?", ":"", plainenv);
       } else {
           printf("\n");
       }
    }
    return ncase;
}

@ label    = WHITESPACE 
@            [ <'|'> WHITESPACE : VV(3) = V(1); : ]
@            cstuff 
@            WHITESPACE
@            [ <'|'> WHITESPACE : VV(3) = V(1); : ]
@            COLON
@            :VV(4)=V(1);getname(&V(1));:

@ labeld   = WHITESPACE 
@            [ <'|'> WHITESPACE : VV(3) = V(1); : ]
@            [ <'|'> WHITESPACE : VV(3) = V(1); : ]
@            COLON
@            WHITESPACE
@            { COLON | : VV(0) = ""; : }
@            :VV(4)=V(1);:


/* content element of a generalized literal - A:expr */
@ caselmt =  label 
@            { WHITESPACE : VV(1) = (char *) 1; : }
@            { label WHITESPACE : VV(3) = (char *)((int)V(1) + 1); addcase(V(0),NULL);V(0)=V(2); : }*
@            expression
@            WHITESPACE 
@            :char *n; VV(4) = (GETNEWNAME(&n,plainenv),addcase(V(1),n),P_REN(n, V(3)),(char *)(ncase - (int)V(2))); : 

@ caselmtd = labeld WHITESPACE expression WHITESPACE 
@            :char *n; VV(4) = (GETNEWNAME(&n,plainenv),addcase(NULL,n),P_REN(n, V(3)),(char *)(ncase - 1)); : 

# define MAXIFS 256
int n_if = 0;
char *ifs[MAXIFS][2];
/*
 * free memory for cases n <= x < ncase
 */
void freeifs(int n) {
    while(--n_if >= n) {

        int i;

        for (i = 0; i < 2; i++)  {
            if (ifs[n_if][i])
                free(ifs[n_if][i]);
        }
    }
    n_if++;
}
int addif(char *label, char *fn) {
    if (n_if >= MAXIFS)
        return -1;
    ifs[n_if][0] = label ? strdup(label) : NULL;
    ifs[n_if][1] = fn ?    strdup(fn)    : NULL;
    return n_if++;
}
/*
 * print out if's for n <= x < n_if
 */
int dumpifs(int offset, int n) {

    int i, j;

    for (i = n; i < n_if; i++) {
       for (j = 0; j < offset; j++) {
           printf(" ");
       }
       if (ifs[i][0]) {
           printf("} else if (%s(*self->_pstr%s%s)) {\n",
               ifs[i][0], !ISEMPTY(plainenv)?", ":"", plainenv);
       } else {
           printf("} else {\n");
       }
       if (ifs[i][1]) {
           for (j = 0; j < offset; j++) {
               printf(" ");
           }
           printf("    return %s(self%s%s);\n",
               GNAME(ifs[i][1]), !ISEMPTY(plainenv)?", ":"", plainenv);
       } else {
           printf("\n");
       }
    }
    return n_if;
}

@ ifelmt =   label 
@            { WHITESPACE : VV(1) = (char *) 1; : }
@            { label WHITESPACE : VV(3) = (char *)((int)V(1) + 1); addif(V(0),NULL);V(0)=V(2); : }*
@            expression
@            WHITESPACE 
@            :char *n; VV(4) = (GETNEWNAME(&n,plainenv),addif(V(1),n),P_REN(n, V(3)),(char *)(n_if - (int)V(2))); : 

@ ifelmtd =  labeld WHITESPACE expression WHITESPACE 
@            :char *n; VV(4) = (GETNEWNAME(&n,plainenv),addif(NULL,n),P_REN(n, V(3)),(char *)(n_if - 1)); : 



/* ------------------------------------------------------------------- */


/* ---------------------- large "tokens" ----------------------------- */

@ LITERAL  = LEFTANGLEBRACKET
@            lits 
@            RIGHTANGLEBRACKET
@          : VV(3) = V(2); :
@          | CHARCONST :VV(1)=V(1);getname(&V(1));:

@ ANTILITERAL = RIGHTANGLEBRACKET
@            alits
@            LEFTANGLEBRACKET 
@          : VV(3) = V(2) ; : 

/* ------------------------------------------------------------------- */

@ literal = LITERAL 
@  :char *n;VV(1)=(GETNEWNAME(&n,plainenv),P_LIT(n,V(1))); :

@ lswitch = OPENBRACE
@           WHITESPACE
@           : char *n; getname(&n); :
@           caselmt { SEMICOLON caselmt    : VV(3) = V(1); : }*
@                   [ SEMICOLON caselmtd   : VV(3) = V(1); : ]
@                   [ SEMICOLON            : VV(2) = V(1); : ]
@           WHITESPACE
@           CLOSEBRACE
@  :char *n; VV(5) = (GETNEWNAME(&n,plainenv),P_GEN(n,(int)V(3))); : 

@ antiliteral = ANTILITERAL
@  :char *n;VV(1)=(GETNEWNAME(&n,plainenv),P_ALI(n,V(1))); :

@ range = OPENPAREN WHITESPACE expr WHITESPACE CLOSEPAREN
@  :char *n;VV(5)=(getname(&V(3)),GETNEWNAME(&n,plainenv),P_RAN(n,V(3)));:

@ rswitch = OPENPAREN
@           WHITESPACE
@           : char *n; getname(&n); :
@           ifelmt  { SEMICOLON ifelmt     : VV(3) = V(1); : }*
@                   [ SEMICOLON ifelmtd    : VV(3) = V(1); : ]
@                   [ SEMICOLON            : VV(2) = V(1); : ]
@           WHITESPACE
@           CLOSEPAREN
@  :char *n; VV(5) = (GETNEWNAME(&n,plainenv),P_GENR(n,(int)V(3))); : 


@ test = CLOSEPAREN WHITESPACE expr WHITESPACE OPENPAREN
@  :char *n;VV(5)=(getname(&V(3)),GETNEWNAME(&n,plainenv),P_TST(n,V(3)));:

char *trim_trailing_paren(char *x) {
    int n = strlen(x);
    if (n > 0 && x[n-1] == '(') {
        x[n-1] = 0;    
    }
    return x;
}

@ brackettest = OPENBRACE CLOSEPAREN WHITESPACE tlits WHITESPACE CLOSEBRACE
@  :char *n;VV(6)=(GETNEWNAME(&n,plainenv),P_TST(n,trim_trailing_paren(V(4))));:
@             | CLOSEPAREN OPENBRACE WHITESPACE atlits WHITESPACE CLOSEBRACE OPENPAREN
@  :char *n;VV(7)=(GETNEWNAME(&n,plainenv),P_TST(n,V(4))); :

@ beginmatch  = CARET : VV(1)="p_first0"; :

@ finishmatch = DOLLAR : VV(1)="p_last0"; :

@ plingmatch  = PLING : VV(1)="p_uniq0"; :

@ dollarplingmatch = DOLLAR PLING : VV(2)="p_lastuniq0"; :

@ eofmatch = DOLLAR DOLLAR : VV(2)="p_eof0"; :

                /* another overpull */

@ plusop = PLUS
@              : char *n;VV(2)=(GETNEWNAME(&n,plainenv),P_SOM(n,V(1))); :

@ hideop = SLASH OPENPAREN expr CLOSEPAREN
@  :char *n;
@   VV(5)=(getname(&V(4)),GETNEWNAME(&n,plainenv),P_HID(n,V(1),V(4)));:


                /* ------- finis -------- */

                /* ---- ampliaciones ---- */
/* !(func) : llamada a funcion (no admite parametros)
   retorno 0/1 : falla/sigue
*/
@ plingcall = PLING OPENPAREN WHITESPACE expr WHITESPACE CLOSEPAREN
@  :char *n;VV(6)=(getname(&V(4)),GETNEWNAME(&n,plainenv),P_CAL(n,V(4)));:

/* ... pred  : avanzar hasta pred */
@ untilmatch = ELLIPSIS WHITESPACE seqoperand
@   : char *n;VV(3)=(GETNEWNAME(&n,plainenv),P_UNT(n,V(3))); :

/* #pred : no pred
   falla si se cumple pred
*/
@ notseqoperand = <'#'> seqoperand
@   : char *n;VV(2)=(GETNEWNAME(&n,plainenv),P_NOT(n,V(2))); :

void p_pfinish() {
    if (!protos)
      return;
    fprintf(protos,"P_END\n");
    fclose(protos);
}


MAIN(line)









