
# define MAXPROGRAMSIZE 64000 
# define READBUFFERSIZE 16000

int my_yywrap() { return 0; }

# define BEGIN {self->yywrap = my_yywrap;}
# define DEBUG 1 

#include "ccx.h"
#include "REC-xml.h"


# undef DEBUG

/* ------------------------------ constructions ------------------------ */

                   /* match a sequence of chars */

@ String(s)      = ) *(char*)s==0 (
@                | < *(char*)s > String( ((char*)s) + 1 )

                   /* match one of a set of chars */

@ CharSet(s)     = ) *(char*)s!=0 ( { <*(char*)s> |   CharSet( ((char*)s) + 1) }

                   /* the EBNF construction A - B */

@ Except(a,b)    = [b {@ 1 @}]\x  )!x(  a

                   /* one of a range of chars */

@ CharRange(x,y) = ?\z  ) (int)z>=x && (int)z<=y (

                   /* a unicode char. Change when TOKEN=short. This is for TOKEN=char */

@ UC(x)          = )x>=0 && x<=255( <x>

                   /* a char not among a given set of chars */

@ CompCharSet(s) = [CharSet(s) {@ 1 @}]\x  )!x(  {?|NL}

                   /* provide strndup for thos who like it */

#define MAXENTRIES 4096
static int nentries;
static char* stuff[MAXENTRIES];
int cmp(char *s, char *t, int n) {
       while (n-->0) {  /* compare module '\n' == 0 */
         char c = *s++, d = *t++;
         if (!c || (c != d && ~(c == '\n' && !d || !c && d == '\n')))
            return -1;
       }
       return 0;
 }
char * find(char *s, int n) {
     int i;
     for (i = 0; i < nentries; i++) {
       if (!cmp(stuff[i],s,n))
         return stuff[i];
     }
     return NULL;
}
char *store(char *s, int n) {
     char * t = NULL;
     if (nentries >= MAXENTRIES)
        return NULL;
     t = malloc(n+1);
     if (!t)
       return NULL;
     memcpy(t,s,n);
     t[n] = 0;
     while (n-->0) {
       if (!t[n])
         t[n] = '\n';
     }
     stuff[nentries++] = t;
     return t;
}
char * strndup(char *s, int n) {
     char *t = NULL;
     t = find(s,n);
     if (t) 
       return t;
     t = store(s,n);
     return t;
}


@ show(p)        = {@ pstr @}\a p  {@ pstr @}\b {@ strndup(a,b-a) @}

/* ------------------------ additional definitions ------------------------ */

@ Chars0  = Char+              /* changed from *  (ptb) */

@ Chars1  = CompCharSet("<&")+    /* changed from *  (ptb) */

@ Chars2  = CompCharSet("<&")* String("]]>")   CompCharSet("<&")*

@ Chars3  = Char* String("?>") Char*

@ Chars4  = Char* String("]]>") Char*

@ Chars5  = Char* {String("<![") | String("]]>")} Char*

@  Apostrophe   = <'\''>

@ Chars6 = {<'X'> | <'x'>} {<'M'> | <'m'>} {<'L'> | <'l'>}

@ Minus   = <'-'>

int lineno = 1;

@ NL     = {: lineno++; :} $

@ TheRest = {?|NL}*

@ error   = show(TheRest)\s {: printf("error in line %d ... %s\n",lineno,s); :}

# define DEBUG 1 

/* ------ http://www.w3.org/TR/REC-xml Rules start here --------------------- */

  /*[1]*/

@ document = prolog     {: printf("done prolog!\n"); :}  !{error}
@            element    {: printf("done element!\n"); :} !{error}
@            Misc*      {: printf("done Misc*!\n"); :}   !{error}
@            $$ !

  /*[2]*/

@ Char = UC(0x9)
@      | UC(0xA) | NL
@      | UC(0xD)
@      | CharRange(0x20,0xD7FF)
@      | CharRange(0xE000,0xFFFD)
@      | CharRange(0x10000,0x10FFFF)                
                                                  
          /* any Unicode character, excluding the surrogateblocks, FFFE, and FFFF.  */

  /*[3]*/

@ S = { UC(0x20) | UC(0x9) | UC(0xD) | UC(0xA) | NL }+

  /*[4]*/

@ NameChar = Letter
@          | Digit
@          | <'.'>
@          | <'-'>
@          | <'_'>
@          | <':'>
@          | CombiningChar
@          | Extender

  /*[5]*/

@     Name = {Letter | <'_'> | <':'>} NameChar*

  /*[6]*/

@    Names = Name {S Name}*

  /*[7]*/

@  Nmtoken = NameChar+

  /*[8]*/

@ Nmtokens = Nmtoken {S Nmtoken}*

   /*[9]*/

@ EntityValue = <'"'>  {   CompCharSet("%&\"") | PEReference | Reference }* <'"'>
@             | <'\''> {   CompCharSet("%&'")  | PEReference | Reference }* <'\''>

  /*[10]*/

@  AttValue = <'"'>  {  CompCharSet("<&\"") | Reference }* <'"'>
@           | <'\''> {  CompCharSet("<&'")  | Reference }* <'\''>

  /*[11]*/

@  SystemLiteral = <'"'>   CompCharSet("\"")* <'"'>
@                | <'\''>   CompCharSet("'")* <'\''>

  /*[12]*/

@  PubidLiteral = <'"'> PubidChar* <'"'>
@               | <'\''> Except(PubidChar,Apostrophe)* <'\''>

  /*[13]*/

@     PubidChar = UC(0x20)
@               | UC(0xD)
@               | UC(0xA) | NL
@               | CharRange('a','z')
@               | CharRange('A','Z')
@               | CharRange('0','9')
@               | CharSet("-'()+,./:=?;!*#@$_%")

  /*[14]*/

@ CharData = Except(Chars1,Chars2)

  /*[15]*/

@ Comment = String("<!--") { Except(Char,Minus) | <'-'> Except(Char,Minus) }* String("-->")

  /*[16]*/

@       PI = String("<?") PITarget [S Except(Chars0,Chars3)*] String("?>")        /* * added to Except by ptb */

  /*[17]*/

@ PITarget = Except(Name,Chars6)

  /*[18]*/

@  CDSect = CDStart CData CDEnd

  /*[19]*/

@ CDStart = String("<![CDATA[")

  /*[20]*/


@   CData = Except(Chars0,Chars4)*    /* * added by PTB */

  /*[21]*/

@   CDEnd = String("]]>")

  /*[22]*/

@      prolog = [XMLDecl]                      {: printf("done XMLDecl!\n"); :}  !{error}
@               Misc*                          {: printf("done Misc*!\n"); :}  !{error}
@               [doctypedecl Misc*]            {: printf("done [doctypedecl Misc*]!\n"); :}  !{error}


  /*[23]*/

@     XMLDecl = String("<?xml") VersionInfo [EncodingDecl] [SDDecl] [S] String("?>")

  /*[24]*/

@ VersionInfo = S String("version") Eq {<'\''> VersionNum <'\''> | <'"'> VersionNum <'"'>}

  /*[25]*/

@          Eq = [S] <'='> [S]

  /*[26]*/

@  VersionNum = {CharRange('a','z') | CharRange('A','Z') | CharRange('0','9') |   CharSet("_.:") | <'-'>}+

  /*[27]*/

@        Misc = Comment | PI |  S


  /*[28]*/

@ doctypedecl = String("<!DOCTYPE")                      {: printf("done <!DOCTYPE !\n"); :}  !{error}
@               S show(Name)\x                           {: printf("done Name! = %s\n",x); :} !{error}
@               [S ExternalID]                           {: printf("done [ExternalID]!\n"); :} 
@               [S] [<'['>                               {: printf("done [ !\n"); :}          !{error}
@                          { markupdecl                  {: printf("done markupdecl !\n"); :}
@                          | PEReference                 {: printf("done PEReference!\n"); :}
@                          | S
@                          }*
@                    <']'> [S]                           {: printf("done ] !\n"); :}
@                   ]                                    {: printf("done [doctypedecl internals]!\n"); :}  !{error}
@               <'>'>                                    {: printf("done > !\n"); :} 

  /*[29]*/

@  markupdecl = elementdecl | AttlistDecl  | EntityDecl | NotationDecl | PI | Comment             

  /*[30]*/

@     extSubset = [TextDecl] extSubsetDecl

  /*[31]*/

@ extSubsetDecl = { markupdecl | conditionalSect | PEReference | S }*

  /*[32]*/

@ SDDecl = S String("standalone") Eq
@            { <'\''> { String("yes")| String("no") } <'\''>
@            | <'"'>  { String("yes") | String("no") } <'"'>
@            }

  /*[33]*/

@ LanguageID = Langcode {<'-'> Subcode}*

  /*[34]*/

@   Langcode = ISO639Code |  IanaCode |  UserCode

  /*[35]*/

@ ISO639Code = {CharRange('a','z') | CharRange('A','Z')} {CharRange('a','z') | CharRange('A','Z')}

  /*[36]*/

@   IanaCode = {<'i'> | <'I'>} <'-'> {CharRange('a','z') | CharRange('A','Z')}+

  /*[37]*/

@   UserCode = {<'x'> | <'X'>} <'-'> {CharRange('a','z') | CharRange('A','Z')}+

  /*[38]*/

@    Subcode = {CharRange('a','z') | CharRange('A','Z')}+

  /*[39]*/

@ element = EmptyElemTag           {: printf("done EmptyElemTag !\n"); :}  !{error}
@         | STag                   {: printf("done STag !\n"); :}  !{error}
@           content                {: printf("done content !\n"); :} 
@           ETag                   {: printf("done ETag !\n"); :}  !{error}

  /*[40]*/

@      STag = <'<'> Name {S Attribute}* [S] <'>'>

  /*[41]*/

@ Attribute = Name Eq AttValue 

  /*[42]*/

@ ETag = String("</") Name [S] <'>'>

  /*[43]*/

@ content = {element | CharData | Reference | CDSect | PI | Comment}*

  /*[44]*/

@ EmptyElemTag = <'<'> Name {S Attribute}* [S]  String("/>") 

  /*[45]*/

@ elementdecl = String("<!ELEMENT") S Name S contentspec [S] <'>'>
  /*[46]*/

@ contentspec = String("EMPTY") | String("ANY") | Mixed | children

  /*[47]*/

@ children = {choice | seq} [<'?'> | <'*'> | <'+'>]

  /*[48]*/

@       cp = {Name | choice | seq} [<'?'> | <'*'> | <'+'>]

  /*[49]*/

@   choice = <'('> [S] cp { [S] <'|'> [S] cp }* [S] <')'> 

  /*[50]*/

@      seq = <'('> [S] cp { [S] <','> [S] cp }* [S] <')'> 

  /*[51]*/

@ Mixed = <'('> [S] String("#PCDATA") {[S] <'|'> [S] Name}* [S] String(")*")
@       | <'('> [S] String("#PCDATA") [S] <')'>

  /*[52]*/

@ AttlistDecl = String("<!ATTLIST") S Name AttDef* [S] <'>'>

  /*[53]*/

@      AttDef = S Name S AttType S DefaultDecl

  /*[54]*/

@       AttType = StringType
@               | TokenizedType
@               | EnumeratedType

  /*[55]*/

@    StringType = String("CDATA")

  /*[56]*/

@ TokenizedType = String("ID")
@               | String("IDREF")
@               | String("IDREFS")
@               | String("ENTITY")
@               | String("ENTITIES")
@               | String("NMTOKEN")
@               | String("NMTOKENS")

  /*[57]*/

@ EnumeratedType = NotationType
@               | Enumeration

  /*[58]*/

@   NotationType = String("NOTATION") S <'('> [S] Name {[S] <'|'> [S] Name}* [S] <')'>

  /*[59]*/

@    Enumeration = <'('> [S] Nmtoken {[S] <'|'> [S] Nmtoken}* [S] <')'>

  /*[60]*/

@ DefaultDecl = String("#REQUIRED") | String("#IMPLIED") | [String("#FIXED") S]  AttValue

  /*[61]*/

@    conditionalSect = includeSect | ignoreSect

  /*[62]*/

@        includeSect = String("<![") [S] String("INCLUDE") [S] <'['> extSubsetDecl String("]]>")

  /*[63]*/

@         ignoreSect = String("<![") [S] String("IGNORE") [S] <'['> ignoreSectContents+ String("]]>") /* * changed to + by ptb */

  /*[64]*/

@ ignoreSectContents = [Ignore] {String("<![") ignoreSectContents String("]]>") [Ignore]}+     /* [] added to Ignore by ptb */
@                    | Ignore /* added by ptb */

  /*[65]*/


@             Ignore = Except(Chars0, Chars5)


  /*[66]*/

@ CharRef = String("&#") CharRange('0','9')+ <';'>
@         | String("&#x") {CharRange('0','9') | CharRange('a','f')|CharRange('A','F')}+ <';'> 

  /*[67]*/

@   Reference = EntityRef
@             | CharRef

  /*[68]*/

@   EntityRef = <'&'> Name <';'>

  /*[69]*/

@ PEReference = <'%'> Name <';'>

  /*[70]*/

@ EntityDecl = GEDecl
@            | PEDecl

  /*[71]*/

@     GEDecl = String("<!ENTITY") S Name S EntityDef [S] <'>'>

  /*[72]*/

@     PEDecl = String("<!ENTITY") S <'%'> S Name S PEDef [S] <'>'>

  /*[73]*/

@  EntityDef = EntityValue
@            | ExternalID [NDataDecl]

  /*[74]*/

@      PEDef = EntityValue
@            | ExternalID

  /*[75]*/

@ ExternalID = String("SYSTEM") S SystemLiteral
@            | String("PUBLIC") S PubidLiteral S SystemLiteral

  /*[76]*/

@  NDataDecl = S String("NDATA") S Name

  /*[77]*/

@ TextDecl = String("<?xml") [VersionInfo] EncodingDecl [S] String("?>")

  /*[78]*/

@ extParsedEnt = [TextDecl] content

  /*[79]*/

@        extPE = [TextDecl] extSubsetDecl

  /*[80]*/

@ EncodingDecl = S String("encoding") Eq {<'"'> EncName <'"'> |  <'\''> EncName <'\''> }

  /*[81]*/

@      EncName = {CharRange('A','Z')|CharRange('a','z')} {CharRange('A','Z')|CharRange('a','z')|CharRange('0','9')|CharSet("._")| <'-'>}* 

        /* Encoding name contains only Latin characters */

  /*[82]*/

@ NotationDecl = String("<!NOTATION") S Name S {ExternalID |  PublicID} [S]  <'>'>

  /*[83]*/

@     PublicID = String("PUBLIC") S PubidLiteral

  /*[84] */

@     Letter   = BaseChar | Ideographic

         /* [85] */ 

@     BaseChar =  BaseChar0
@              |  BaseChar1
@              |  BaseChar2
@              |  BaseChar3
@              |  BaseChar4
@              |  BaseChar5
@              |  BaseChar6
@              |  BaseChar7

# undef DEBUG

@     BaseChar0 =                CharRange(0x0041,0x005A) | CharRange(0x0061,0x007A) | CharRange(0x00C0,0x00D6)
@                              | CharRange(0x00D8,0x00F6) | CharRange(0x00F8,0x00FF) | CharRange(0x0100,0x0131)
@                              | CharRange(0x0134,0x013E) | CharRange(0x0141,0x0148) | CharRange(0x014A,0x017E)
@                              | CharRange(0x0180,0x01C3) | CharRange(0x01CD,0x01F0) | CharRange(0x01F4,0x01F5)
@                              | CharRange(0x01FA,0x0217) | CharRange(0x0250,0x02A8) | CharRange(0x02BB,0x02C1) | UC(0x0386)
@                              | CharRange(0x0388,0x038A) | UC(0x038C) | CharRange(0x038E,0x03A1) | CharRange(0x03A3,0x03CE)
@                              | CharRange(0x03D0,0x03D6) | UC(0x03DA) | UC(0x03DC) | UC(0x03DE) | UC(0x03E0)

@     BaseChar1 =                CharRange(0x03E2,0x03F3) | CharRange(0x0401,0x040C) | CharRange(0x040E,0x044F)
@                              | CharRange(0x0451,0x045C) | CharRange(0x045E,0x0481) | CharRange(0x0490,0x04C4)
@                              | CharRange(0x04C7,0x04C8) | CharRange(0x04CB,0x04CC) | CharRange(0x04D0,0x04EB)
@                              | CharRange(0x04EE,0x04F5) | CharRange(0x04F8,0x04F9) | CharRange(0x0531,0x0556) | UC(0x0559)
@                              | CharRange(0x0561,0x0586) | CharRange(0x05D0,0x05EA) | CharRange(0x05F0,0x05F2)
@                              | CharRange(0x0621,0x063A) | CharRange(0x0641,0x064A) | CharRange(0x0671,0x06B7)
@                              | CharRange(0x06BA,0x06BE) | CharRange(0x06C0,0x06CE) | CharRange(0x06D0,0x06D3) | UC(0x06D5)

@     BaseChar2 =                CharRange(0x06E5,0x06E6) | CharRange(0x0905,0x0939) | UC(0x093D) | CharRange(0x0958,0x0961)
@                              | CharRange(0x0985,0x098C) | CharRange(0x098F,0x0990) | CharRange(0x0993,0x09A8)
@                              | CharRange(0x09AA,0x09B0) | UC(0x09B2) | CharRange(0x09B6,0x09B9) | CharRange(0x09DC,0x09DD)
@                              | CharRange(0x09DF,0x09E1) | CharRange(0x09F0,0x09F1) | CharRange(0x0A05,0x0A0A)
@                              | CharRange(0x0A0F,0x0A10) | CharRange(0x0A13,0x0A28) | CharRange(0x0A2A,0x0A30)
@                              | CharRange(0x0A32,0x0A33) | CharRange(0x0A35,0x0A36) | CharRange(0x0A38,0x0A39)
@                              | CharRange(0x0A59,0x0A5C) | UC(0x0A5E) | CharRange(0x0A72,0x0A74) | CharRange(0x0A85,0x0A8B)

@    BaseChar3 =                 UC(0x0A8D) | CharRange(0x0A8F,0x0A91) | CharRange(0x0A93,0x0AA8) | CharRange(0x0AAA,0x0AB0)
@                              | CharRange(0x0AB2,0x0AB3) | CharRange(0x0AB5,0x0AB9) | UC(0x0ABD) | UC(0x0AE0)
@                              | CharRange(0x0B05,0x0B0C) | CharRange(0x0B0F,0x0B10) | CharRange(0x0B13,0x0B28)
@                              | CharRange(0x0B2A,0x0B30) | CharRange(0x0B32,0x0B33) | CharRange(0x0B36,0x0B39) | UC(0x0B3D)
@                              | CharRange(0x0B5C,0x0B5D) | CharRange(0x0B5F,0x0B61) | CharRange(0x0B85,0x0B8A)
@                              | CharRange(0x0B8E,0x0B90) | CharRange(0x0B92,0x0B95) | CharRange(0x0B99,0x0B9A) | UC(0x0B9C)
@                              | CharRange(0x0B9E,0x0B9F) | CharRange(0x0BA3,0x0BA4) | CharRange(0x0BA8,0x0BAA)

@   BaseChar4 =                  CharRange(0x0BAE,0x0BB5) | CharRange(0x0BB7,0x0BB9) | CharRange(0x0C05,0x0C0C)
@                              | CharRange(0x0C0E,0x0C10) | CharRange(0x0C12,0x0C28) | CharRange(0x0C2A,0x0C33)
@                              | CharRange(0x0C35,0x0C39) | CharRange(0x0C60,0x0C61) | CharRange(0x0C85,0x0C8C)
@                              | CharRange(0x0C8E,0x0C90) | CharRange(0x0C92,0x0CA8) | CharRange(0x0CAA,0x0CB3)
@                              | CharRange(0x0CB5,0x0CB9) | UC(0x0CDE) | CharRange(0x0CE0,0x0CE1) | CharRange(0x0D05,0x0D0C)
@                              | CharRange(0x0D0E,0x0D10) | CharRange(0x0D12,0x0D28) | CharRange(0x0D2A,0x0D39)
@                              | CharRange(0x0D60,0x0D61) | CharRange(0x0E01,0x0E2E) | UC(0x0E30) | CharRange(0x0E32,0x0E33)

@   BaseChar5 =                  CharRange(0x0E40,0x0E45) | CharRange(0x0E81,0x0E82) | UC(0x0E84) | CharRange(0x0E87,0x0E88)
@                              | UC(0x0E8A) | UC(0x0E8D) | CharRange(0x0E94,0x0E97) | CharRange(0x0E99,0x0E9F)
@                              | CharRange(0x0EA1,0x0EA3) | UC(0x0EA5) | UC(0x0EA7) | CharRange(0x0EAA,0x0EAB)
@                              | CharRange(0x0EAD,0x0EAE) | UC(0x0EB0) | CharRange(0x0EB2,0x0EB3) | UC(0x0EBD)
@                              | CharRange(0x0EC0,0x0EC4) | CharRange(0x0F40,0x0F47) | CharRange(0x0F49,0x0F69)
@                              | CharRange(0x10A0,0x10C5) | CharRange(0x10D0,0x10F6) | UC(0x1100) | CharRange(0x1102,0x1103)
@                              | CharRange(0x1105,0x1107) | UC(0x1109) | CharRange(0x110B,0x110C) | CharRange(0x110E,0x1112)

@    BaseChar6 =                 UC(0x113C) | UC(0x113E) | UC(0x1140) | UC(0x114C) | UC(0x114E) | UC(0x1150)
@                              | CharRange(0x1154,0x1155) | UC(0x1159) | CharRange(0x115F,0x1161) | UC(0x1163) | UC(0x1165)
@                              | UC(0x1167) | UC(0x1169) | CharRange(0x116D,0x116E) | CharRange(0x1172,0x1173) | UC(0x1175)
@                              | UC(0x119E) | UC(0x11A8) | UC(0x11AB) | CharRange(0x11AE,0x11AF) | CharRange(0x11B7,0x11B8)
@                              | UC(0x11BA) | CharRange(0x11BC,0x11C2) | UC(0x11EB) | UC(0x11F0) | UC(0x11F9)
@                              | CharRange(0x1E00,0x1E9B) | CharRange(0x1EA0,0x1EF9) | CharRange(0x1F00,0x1F15)
@                              | CharRange(0x1F18,0x1F1D) | CharRange(0x1F20,0x1F45) | CharRange(0x1F48,0x1F4D)

@    BaseChar7 =                 CharRange(0x1F50,0x1F57) | UC(0x1F59) | UC(0x1F5B) | UC(0x1F5D) | CharRange(0x1F5F,0x1F7D)
@                              | CharRange(0x1F80,0x1FB4) | CharRange(0x1FB6,0x1FBC) | UC(0x1FBE) | CharRange(0x1FC2,0x1FC4)
@                              | CharRange(0x1FC6,0x1FCC) | CharRange(0x1FD0,0x1FD3) | CharRange(0x1FD6,0x1FDB)
@                              | CharRange(0x1FE0,0x1FEC) | CharRange(0x1FF2,0x1FF4) | CharRange(0x1FF6,0x1FFC) | UC(0x2126)
@                              | CharRange(0x212A,0x212B) | UC(0x212E) | CharRange(0x2180,0x2182) | CharRange(0x3041,0x3094)
@                              | CharRange(0x30A1,0x30FA) | CharRange(0x3105,0x312C) | CharRange(0xAC00,0xD7A3) 

         /* [86]  */

@              Ideographic  = CharRange(0x4E00,0x9FA5) | UC(0x3007) | CharRange(0x3021,0x3029) 

         /* [87]  */

@        CombiningChar  = CombiningChar0 | CombiningChar1 | CombiningChar2 | CombiningChar3


@        CombiningChar0 =        CharRange(0x0300,0x0345) | CharRange(0x0360,0x0361) | CharRange(0x0483,0x0486)
@                              | CharRange(0x0591,0x05A1) | CharRange(0x05A3,0x05B9) | CharRange(0x05BB,0x05BD) | UC(0x05BF)
@                              | CharRange(0x05C1,0x05C2) | UC(0x05C4) | CharRange(0x064B,0x0652) | UC(0x0670)
@                              | CharRange(0x06D6,0x06DC) | CharRange(0x06DD,0x06DF) | CharRange(0x06E0,0x06E4)
@                              | CharRange(0x06E7,0x06E8) | CharRange(0x06EA,0x06ED) | CharRange(0x0901,0x0903) | UC(0x093C)

@        CombiningChar1 =        CharRange(0x093E,0x094C) | UC(0x094D) | CharRange(0x0951,0x0954) | CharRange(0x0962,0x0963)
@                              | CharRange(0x0981,0x0983) | UC(0x09BC) | UC(0x09BE) | UC(0x09BF) | CharRange(0x09C0,0x09C4)
@                              | CharRange(0x09C7,0x09C8) | CharRange(0x09CB,0x09CD) | UC(0x09D7) | CharRange(0x09E2,0x09E3)
@                              | UC(0x0A02) | UC(0x0A3C) | UC(0x0A3E) | UC(0x0A3F) | CharRange(0x0A40,0x0A42)
@                              | CharRange(0x0A47,0x0A48) | CharRange(0x0A4B,0x0A4D) | CharRange(0x0A70,0x0A71)
@                              | CharRange(0x0A81,0x0A83) | UC(0x0ABC) | CharRange(0x0ABE,0x0AC5) | CharRange(0x0AC7,0x0AC9)
@                              | CharRange(0x0ACB,0x0ACD) | CharRange(0x0B01,0x0B03) | UC(0x0B3C) | CharRange(0x0B3E,0x0B43)

@        CombiningChar2 =        CharRange(0x0B47,0x0B48) | CharRange(0x0B4B,0x0B4D) | CharRange(0x0B56,0x0B57)
@                              | CharRange(0x0B82,0x0B83) | CharRange(0x0BBE,0x0BC2) | CharRange(0x0BC6,0x0BC8)
@                              | CharRange(0x0BCA,0x0BCD) | UC(0x0BD7) | CharRange(0x0C01,0x0C03) | CharRange(0x0C3E,0x0C44)
@                              | CharRange(0x0C46,0x0C48) | CharRange(0x0C4A,0x0C4D) | CharRange(0x0C55,0x0C56)
@                              | CharRange(0x0C82,0x0C83) | CharRange(0x0CBE,0x0CC4) | CharRange(0x0CC6,0x0CC8)
@                              | CharRange(0x0CCA,0x0CCD) | CharRange(0x0CD5,0x0CD6) | CharRange(0x0D02,0x0D03)
@                              | CharRange(0x0D3E,0x0D43) | CharRange(0x0D46,0x0D48) | CharRange(0x0D4A,0x0D4D) | UC(0x0D57)

@        CombiningChar3 =        UC(0x0E31) | CharRange(0x0E34,0x0E3A) | CharRange(0x0E47,0x0E4E) | UC(0x0EB1)
@                              | CharRange(0x0EB4,0x0EB9) | CharRange(0x0EBB,0x0EBC) | CharRange(0x0EC8,0x0ECD)
@                              | CharRange(0x0F18,0x0F19) | UC(0x0F35) | UC(0x0F37) | UC(0x0F39) | UC(0x0F3E) | UC(0x0F3F)
@                              | CharRange(0x0F71,0x0F84) | CharRange(0x0F86,0x0F8B) | CharRange(0x0F90,0x0F95) | UC(0x0F97)
@                              | CharRange(0x0F99,0x0FAD) | CharRange(0x0FB1,0x0FB7) | UC(0x0FB9) | CharRange(0x20D0,0x20DC)
@                              | UC(0x20E1) | CharRange(0x302A,0x302F) | UC(0x3099) | UC(0x309A) 

         /* [88]  */

@            Digit  = CharRange(0x0030,0x0039) | CharRange(0x0660,0x0669) | CharRange(0x06F0,0x06F9)
@                   | CharRange(0x0966,0x096F) | CharRange(0x09E6,0x09EF) | CharRange(0x0A66,0x0A6F)
@                   | CharRange(0x0AE6,0x0AEF) | CharRange(0x0B66,0x0B6F) | CharRange(0x0BE7,0x0BEF)
@                   | CharRange(0x0C66,0x0C6F) | CharRange(0x0CE6,0x0CEF) | CharRange(0x0D66,0x0D6F)
@                   | CharRange(0x0E50,0x0E59) | CharRange(0x0ED0,0x0ED9) | CharRange(0x0F20,0x0F29) 

         /* [89]  */

@         Extender = UC(0x00B7) | UC(0x02D0) | UC(0x02D1) | UC(0x0387) | UC(0x0640) | UC(0x0E46) | UC(0x0EC6)
@                  | UC(0x3005) | CharRange(0x3031,0x3035) | CharRange(0x309D,0x309E) | CharRange(0x30FC,0x30FE)


MAIN(document)

